// shadertype=glsl
#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

out vec2 TexCoords;
out vec3 FragPosition;
out vec3 Normal;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat3 normalMat;

void main()
{
    gl_Position = projection * view * model * vec4(position, 1.0f);
    FragPosition = vec3(model * vec4(position, 1.0f));
    Normal = normalMat * normal;
	//Normal = transpose(inverse(mat3(model))) * normal;
    TexCoords = texCoords;
}