#version 330 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

out vec3 fragPos;
out vec3 Normal;
out float detail;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat3 normalMat;

uniform float zMin;
uniform float distanceScale;

void main()
{
	gl_Position = projection * view * model * vec4(position, 1.0f);
	fragPos = vec3(model * vec4(position, 1.0f));
	Normal = normalMat * normal;
	
	detail = 1  - ( (log(gl_Position.z / zMin)) / (log(distanceScale)) );
}