// shadertype=glsl
#version 330 core

struct Material
{
	sampler2D texture_diffuse1;
	float shininess;
}; 

struct DirLight
{
	vec3 direction;
	vec3 intensity;
};

struct PointLight {
	vec3 position;
	
	float constant;
	float linear;
	float quadratic;
	
	vec3 ambient;
	vec3 diffuse;
	vec3 specular;
};

#define NUM_LIGHTS 10

in vec3 fragPos;
in vec3 Normal;
in float detail;

out vec4 color;

//uniform vec3 viewPos;
uniform DirLight dirLight;
uniform PointLight lights[NUM_LIGHTS];
uniform Material material;
uniform float alpha;

// Function prototypes
//vec3 CalcDirLight(DirLight light, Material mat, vec3 normal, vec3 fragPos, vec3 viewDir);

void main()
{    

	//vec3 viewDir = normalize(viewPos - FragPosition);
	vec3 norm = normalize(Normal);
	vec3 l = normalize(-dirLight.direction);
	
	float tone = max(0.0f, dot(norm, l));
	/*
	for (int i = 0; i < NUM_LIGHTS; i++)
	{
		l = normalize(lights[i].position - fragPos);
		tone += max(0.0f, dot(norm, l));
	}
  */
	
	// flip y-coordinates since SOIL texture loading rotates the image such that the origin here would be upper left
	color = texture(material.texture_diffuse1, vec2(tone, 1 - detail));
	color = mix(vec4(dirLight.intensity, 1.0f), color, 0.75);
	color.a = alpha;
}

