#version 330 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

out vec3 fragPos;
out vec3 Normal;
out float detail;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat3 normalMat;

uniform vec3 viewPos;
uniform float magnitude;

void main()
{
	gl_Position = projection * view * model * vec4(position, 1.0);
	fragPos = vec3(model * vec4(position, 1.0));
	Normal = normalMat * normal;
	
	vec3 viewDir = normalize(viewPos - fragPos);
	detail = pow((length(normal * viewDir)), magnitude);
}